Fixes fixes fixes, init.d script
authorJohn Hodge <[email protected]>
Mon, 21 Feb 2011 14:00:23 +0000 (22:00 +0800)
committerJohn Hodge <[email protected]>
Mon, 21 Feb 2011 14:00:23 +0000 (22:00 +0800)
init.d_dispsrv [new file with mode: 0755]
src/client/Makefile
src/client/main.c
src/server/Makefile
src/server/handler_coke.c
src/server/itemdb.c
src/server/main.c
src/server/server.c

diff --git a/init.d_dispsrv b/init.d_dispsrv
new file mode 100755 (executable)
index 0000000..6bafaa3
--- /dev/null
@@ -0,0 +1,159 @@
+#! /bin/sh
+### BEGIN INIT INFO
+# Provides:          dispserv
+# Required-Start:    $syslog
+# Required-Stop:     $syslog
+# Default-Start:     2 3 4 5
+# Default-Stop:      0 1 6
+# Short-Description: Start the OpenDispense2 server
+# Description:       Start the OpenDispense2 server
+#                   written by John Hodge
+### END INIT INFO
+
+# Author: Bob Adamson  <[email protected]>
+
+# Do NOT "set -e"
+
+# PATH should only include /usr/* if it runs after the mountnfs.sh script
+PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin
+DESC="OpenDispense2 server written by John Hodge"
+NAME=dispsrv
+DAEMON=/usr/local/sbin/$NAME
+DAEMON_ARGS="--itemsfile /usr/local/etc/dispsrv/items.cfg -p 11020"
+DAEMON_ARGS=$DAEMON_ARGS" --cokeport /dev/ttyS0"
+DAEMON_ARGS=$DAEMON_ARGS" --doorpass /usr/local/etc/dispsrv/door_password"
+DAEMON_ARGS=$DAEMON_ARGS" --cokebank /var/local/dispsrv/cokebank.db"
+PIDFILE=/var/run/$NAME.pid
+SCRIPTNAME=/etc/init.d/$NAME
+
+# Exit if the package is not installed
+[ -x "$DAEMON" ] || exit 0
+
+# Read configuration variable file if it is present
+[ -r /etc/default/$NAME ] && . /etc/default/$NAME
+
+# Load the VERBOSE setting and other rcS variables
+. /lib/init/vars.sh
+
+# Define LSB log_* functions.
+# Depend on lsb-base (>= 3.2-14) to ensure that this file is present
+# and status_of_proc is working.
+. /lib/lsb/init-functions
+
+#
+# Function that starts the daemon/service
+#
+do_start()
+{
+       # Return
+       #   0 if daemon has been started
+       #   1 if daemon was already running
+       #   2 if daemon could not be started
+       start-stop-daemon --start --quiet --make-pidfile --pidfile $PIDFILE --exec $DAEMON --test > /dev/null \
+               || return 1
+       start-stop-daemon --start --quiet --make-pidfile --pidfile $PIDFILE --exec $DAEMON --background -- \
+               $DAEMON_ARGS \
+               || return 2
+       # Add code here, if necessary, that waits for the process to be ready
+       # to handle requests from services started subsequently which depend
+       # on this one.  As a last resort, sleep for some time.
+}
+
+#
+# Function that stops the daemon/service
+#
+do_stop()
+{
+       # Return
+       #   0 if daemon has been stopped
+       #   1 if daemon was already stopped
+       #   2 if daemon could not be stopped
+       #   other if a failure occurred
+       start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE --name $NAME
+       RETVAL="$?"
+       [ "$RETVAL" = 2 ] && return 2
+       # Wait for children to finish too if this is a daemon that forks
+       # and if the daemon is only ever run from this initscript.
+       # If the above conditions are not satisfied then add some other code
+       # that waits for the process to drop all resources that could be
+       # needed by services started subsequently.  A last resort is to
+       # sleep for some time.
+       start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
+       [ "$?" = 2 ] && return 2
+       # Many daemons don't delete their pidfiles when they exit.
+       rm -f $PIDFILE
+       return "$RETVAL"
+}
+
+#
+# Function that sends a SIGHUP to the daemon/service
+#
+do_reload() {
+       #
+       # If the daemon can reload its configuration without
+       # restarting (for example, when it is sent a SIGHUP),
+       # then implement that here.
+       #
+       start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name $NAME
+       return 0
+}
+
+case "$1" in
+  start)
+       [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
+       do_start
+       case "$?" in
+               0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
+               2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
+       esac
+       ;;
+  stop)
+       [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
+       do_stop
+       case "$?" in
+               0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
+               2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
+       esac
+       ;;
+  status)
+       status_of_proc "$DAEMON" "$NAME" && exit 0 || exit $?
+       ;;
+  #reload|force-reload)
+       #
+       # If do_reload() is not implemented then leave this commented out
+       # and leave 'force-reload' as an alias for 'restart'.
+       #
+       #log_daemon_msg "Reloading $DESC" "$NAME"
+       #do_reload
+       #log_end_msg $?
+       #;;
+  restart|force-reload)
+       #
+       # If the "reload" option is implemented then remove the
+       # 'force-reload' alias
+       #
+       log_daemon_msg "Restarting $DESC" "$NAME"
+       do_stop
+       case "$?" in
+         0|1)
+               do_start
+               case "$?" in
+                       0) log_end_msg 0 ;;
+                       1) log_end_msg 1 ;; # Old process is still running
+                       *) log_end_msg 1 ;; # Failed to start
+               esac
+               ;;
+         *)
+               # Failed to stop
+               log_end_msg 1
+               ;;
+       esac
+       ;;
+  *)
+       #echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
+       echo "Usage: $SCRIPTNAME {start|stop|status|restart|force-reload}" >&2
+       exit 3
+       ;;
+esac
+
+:
index eda60fe..66c21fa 100644 (file)
@@ -16,6 +16,8 @@ clean:
 
 $(BIN): $(OBJ)
        $(CC) -o $(BIN) $(OBJ) $(LDFLAGS)
 
 $(BIN): $(OBJ)
        $(CC) -o $(BIN) $(OBJ) $(LDFLAGS)
+       chown root $(BIN)
+       chmod u+s $(BIN)
 
 %.o: %.c
        $(CC) -c $< -o $@ $(CFLAGS) $(CPPFLAGS)
 
 %.o: %.c
        $(CC) -c $< -o $@ $(CFLAGS) $(CPPFLAGS)
index 5964364..4d33de1 100644 (file)
@@ -29,7 +29,7 @@
 #define DEBUG_TRACE_SERVER     0
 #define USE_AUTOAUTH   1
 
 #define DEBUG_TRACE_SERVER     0
 #define USE_AUTOAUTH   1
 
-#define MAX_TXT_ARGS   4       // Maximum number of textual arguments (including command)
+#define MAX_TXT_ARGS   5       // Maximum number of textual arguments (including command)
 
 enum eUI_Modes
 {
 
 enum eUI_Modes
 {
@@ -102,7 +102,7 @@ char        *gsUserFlags;   //!< User's flag set
 int main(int argc, char *argv[])
 {
         int    sock;
 int main(int argc, char *argv[])
 {
         int    sock;
-        int    i;
+        int    i, ret = 0;
        char    buffer[BUFSIZ];
        char    *text_args[MAX_TXT_ARGS];       // Non-flag arguments
         int    text_argc = 0;
        char    buffer[BUFSIZ];
        char    *text_args[MAX_TXT_ARGS];       // Non-flag arguments
         int    text_argc = 0;
@@ -306,7 +306,7 @@ int main(int argc, char *argv[])
                // Add new user?
                if( strcmp(text_args[1], "add") == 0 )
                {
                // Add new user?
                if( strcmp(text_args[1], "add") == 0 )
                {
-                       if( text_argc != 2 ) {
+                       if( text_argc != 3 ) {
                                fprintf(stderr, "Error: `dispense user add` requires an argument\n");
                                ShowUsage();
                                exit(1);
                                fprintf(stderr, "Error: `dispense user add` requires an argument\n");
                                ShowUsage();
                                exit(1);
@@ -317,7 +317,7 @@ int main(int argc, char *argv[])
                // Update a user
                else if( strcmp(text_args[1], "type") == 0 )
                {
                // Update a user
                else if( strcmp(text_args[1], "type") == 0 )
                {
-                       if( text_argc != 3 ) {
+                       if( text_argc != 4 ) {
                                fprintf(stderr, "Error: `dispense user type` requires two arguments\n");
                                ShowUsage();
                                exit(1);
                                fprintf(stderr, "Error: `dispense user type` requires two arguments\n");
                                ShowUsage();
                                exit(1);
@@ -338,7 +338,7 @@ int main(int argc, char *argv[])
        if( strcmp(text_args[0], "donate") == 0 )
        {
                // Check argument count
        if( strcmp(text_args[0], "donate") == 0 )
        {
                // Check argument count
-               if( text_argc != 2 ) {
+               if( text_argc != 3 ) {
                        fprintf(stderr, "Error: `dispense donate` requires two arguments\n");
                        ShowUsage();
                        exit(1);
                        fprintf(stderr, "Error: `dispense donate` requires two arguments\n");
                        ShowUsage();
                        exit(1);
@@ -517,11 +517,11 @@ int main(int argc, char *argv[])
                Dispense_ItemInfo(sock, gaItems[i].Type, gaItems[i].ID);
                
                Authenticate(sock);
                Dispense_ItemInfo(sock, gaItems[i].Type, gaItems[i].ID);
                
                Authenticate(sock);
-               DispenseItem(sock, gaItems[i].Type, gaItems[i].ID);
+               ret = DispenseItem(sock, gaItems[i].Type, gaItems[i].ID);
                close(sock);
        }
 
                close(sock);
        }
 
-       return 0;
+       return ret;
 }
 
 void ShowUsage(void)
 }
 
 void ShowUsage(void)
@@ -963,8 +963,10 @@ int OpenConnection(const char *Host, int Port)
                fprintf(stderr, "Failed to create socket\n");
                return -1;
        }
                fprintf(stderr, "Failed to create socket\n");
                return -1;
        }
+
+//     printf("geteuid() = %i, getuid() = %i\n", geteuid(), getuid());
        
        
-       if( geteuid() == 0 )
+       if( geteuid() == 0 || getuid() == 0 )
        {
                 int    i;
                struct sockaddr_in      localAddr;
        {
                 int    i;
                struct sockaddr_in      localAddr;
@@ -972,7 +974,7 @@ int OpenConnection(const char *Host, int Port)
                localAddr.sin_family = AF_INET; // IPv4
                
                // Loop through all the top ports until one is avaliable
                localAddr.sin_family = AF_INET; // IPv4
                
                // Loop through all the top ports until one is avaliable
-               for( i = 1001; i < 1024; i ++)
+               for( i = 512; i < 1024; i ++)
                {
                        localAddr.sin_port = htons(i);  // IPv4
                        // Attempt to bind to low port for autoauth
                {
                        localAddr.sin_port = htons(i);  // IPv4
                        // Attempt to bind to low port for autoauth
@@ -981,6 +983,8 @@ int OpenConnection(const char *Host, int Port)
                }
                if( i == 1024 )
                        printf("Warning: AUTOAUTH unavaliable\n");
                }
                if( i == 1024 )
                        printf("Warning: AUTOAUTH unavaliable\n");
+//             else
+//                     printf("Bound to 0.0.0.0:%i\n", i);
        }
        
        if( connect(sock, (struct sockaddr *) &serverAddr, sizeof(serverAddr)) < 0 ) {
        }
        
        if( connect(sock, (struct sockaddr *) &serverAddr, sizeof(serverAddr)) < 0 ) {
index 86e5a42..f73e6c7 100644 (file)
@@ -8,7 +8,7 @@ BIN := ../../dispsrv
 
 DEPFILES := $(OBJ:%.o=%.d)
 
 
 DEPFILES := $(OBJ:%.o=%.d)
 
-LINKFLAGS := -g ../../cokebank.so -lutil -Wl,-rpath,.
+LINKFLAGS := -g ../../cokebank.so -lutil -Wl,-rpath,. -Wl,-rpath,/usr/local/sbin
 CPPFLAGS := 
 CFLAGS := -Wall -Wextra -Werror -g
 
 CPPFLAGS := 
 CFLAGS := -Wall -Wextra -Werror -g
 
index a34d88b..12e2431 100644 (file)
@@ -21,7 +21,7 @@
 #include <pthread.h>
 
 #define READ_TIMEOUT   2       // 2 seconds for ReadChar
 #include <pthread.h>
 
 #define READ_TIMEOUT   2       // 2 seconds for ReadChar
-#define TRACE_COKE     0
+#define TRACE_COKE     1
 
 #if TRACE_COKE
 # define TRACE(v...) do{printf("%s: ",__func__);printf(v);}while(0)
 
 #if TRACE_COKE
 # define TRACE(v...) do{printf("%s: ",__func__);printf(v);}while(0)
@@ -206,11 +206,6 @@ int Coke_DoDispense(int UNUSED(User), int Item)
        TRACE("flushing input\n");
        
 
        TRACE("flushing input\n");
        
 
-       {
-               char buf[512];
-               while( ReadLine(512, buf) != -1 );
-       }
-               
        // Wait for prompt
        ret = 0;
        while( WaitForColon() && ret < 3 )
        // Wait for prompt
        ret = 0;
        while( WaitForColon() && ret < 3 )
@@ -262,6 +257,7 @@ int Coke_DoDispense(int UNUSED(User), int Item)
        TRACE("Updating slot status\n");
        
        // Update status
        TRACE("Updating slot status\n");
        
        // Update status
+       WaitForColon();
        Writef("s%i\r\n", Item);
        len = ReadLine(sizeof tmp, tmp);
        if(len == -1)   gaCoke_CachedStatus[Item] = -1;
        Writef("s%i\r\n", Item);
        len = ReadLine(sizeof tmp, tmp);
        if(len == -1)   gaCoke_CachedStatus[Item] = -1;
index e48ab86..0c4df3f 100644 (file)
@@ -133,6 +133,7 @@ void Items_ReadFromFile(void)
        if(!fp) {
                fprintf(stderr, "Unable to open item file '%s'\n", gsItemListFile);
                perror("Unable to open item file");
        if(!fp) {
                fprintf(stderr, "Unable to open item file '%s'\n", gsItemListFile);
                perror("Unable to open item file");
+               return ;
        }
        
        while( fgets(buffer, BUFSIZ, fp) )
        }
        
        while( fgets(buffer, BUFSIZ, fp) )
index f95637f..eedafc3 100644 (file)
@@ -109,6 +109,11 @@ int main(int argc, char *argv[])
                                char    buf[30];
                                if( i + 1 >= argc )     return -1;
                                fp = fopen(argv[++i], "r");
                                char    buf[30];
                                if( i + 1 >= argc )     return -1;
                                fp = fopen(argv[++i], "r");
+                               if( !fp ) {
+                                       fprintf(stderr, "ERROR: Unable to read password file\n");
+                                       perror("reading LAT password");
+                                       return -1;
+                               }
                                fgets(buf, sizeof buf, fp);
                                fclose(fp);
                                gsDoor_Password = strdup(buf);;
                                fgets(buf, sizeof buf, fp);
                                fclose(fp);
                                gsDoor_Password = strdup(buf);;
index 806ecce..974efca 100644 (file)
@@ -143,6 +143,13 @@ void Server_Start(void)
        
        printf("Listening on 0.0.0.0:%i\n", giServer_Port);
        
        
        printf("Listening on 0.0.0.0:%i\n", giServer_Port);
        
+       // write pidfile
+//     {
+//             FILE *fp = fopen("/var/run/dispsrv.pid", "w");
+//             fprintf(fp, "%i", getpid());
+//             fclose(fp);
+//     }
+
        for(;;)
        {
                uint    len = sizeof(client_addr);
        for(;;)
        {
                uint    len = sizeof(client_addr);
@@ -438,7 +445,7 @@ void Server_Cmd_AUTOAUTH(tClient *Client, char *Args)
        if( Client->UID < 0 ) {
                if(giDebugLevel)
                        Debug(Client, "Unknown user '%s'", username);
        if( Client->UID < 0 ) {
                if(giDebugLevel)
                        Debug(Client, "Unknown user '%s'", username);
-               sendf(Client->Socket, "401 Auth Failure\n");
+               sendf(Client->Socket, "403 Auth Failure\n");
                return ;
        }
        
                return ;
        }
        

UCC git Repository :: git.ucc.asn.au